__author__ = 'kenta'

import requests, urllib2, urllib, json, tornado.httpserver, tornado.websocket, tornado.ioloop, tornado.web, socket, time, thread, pygame
import RPi.GPIO as io

io.setmode(io.BOARD)
pir = 18
globalpin = 0
io.setup(pir, io.IN)

#Set This For your own personal mirror location data
yourhomeaddress = "7 Holly Downs Ct NW Atlanta Georgia"
yourdestination = "Georgia Tech"
yourcity = "Georgia Tech"


#global data for sound
yourname = "Kentaro"
global_travelminute = 1
global_temperature = 1
global_condition = "Sunny"

def get_traffic_api():
    time_duration = ""
    global global_travelminute
    try:
        google_url = "https://maps.googleapis.com/maps/api/distancematrix/json?origins="
        google_url = google_url + yourhomeaddress.replace(" ", "+") + "&destinations=" + yourdestination.replace(" ", "+")
        r = requests.get(google_url, verify=False)
        binary = r.content
        output = json.loads(binary)
        for rows in output['rows']:
            for elements in rows['elements']:
                time_duration = elements['duration']['text'] #text or value work
                global_travelminute = time_duration.replace("mins","").replace(" ", "")
                print global_travelminute
    except:
        time_duration = "Failed to get time"
    return time_duration


def get_word_api():
    word_list = []
    try:
        endpoint = "https://wordsapiv1.p.mashape.com/words/?letterPattern=^[a-zA-Z]*$&hasDetails=definitions&random=true"
        headers = {'X-Mashape-Key': 'GwAJbItaepmshVMtED4JzmYUOh08p1Gf8iNjsnjiAsEr0F3HZI',
                   'Accept': 'application/json'}
        r = requests.get(endpoint, headers=headers, verify=False)
        binary = r.content
        output = json.loads(binary)
        word = output['word']
        partofspeech = output['results'][0]['partOfSpeech']
        definition = output['results'][0]['definition']
        word_list.append(word)
        word_list.append(partofspeech)
        word_list.append(definition)
    except Exception:
        word_list = []
        word_list.append(" ")
        word_list.append(" ")
        word_list.append(" ")
    return word_list


def get_weather_api():
    weather_list = []
    global global_temperature
    try:
        baseurl = "https://query.yahooapis.com/v1/public/yql?"
        yql_query = "select * from weather.forecast where woeid=55862636"
        yql_url = baseurl + urllib.urlencode({'q':yql_query}) + "&format=json"
        result = urllib2.urlopen(yql_url).read()
        output = json.loads(result)
        temperature = output['query']['results']['channel']['item']['condition']['temp']
        global_temperature = temperature
        condition = output['query']['results']['channel']['item']['condition']['text']
        condition_helper(condition)
        weather_list.append(temperature)
        weather_list.append(condition)
    except:
        weather_list = []
        weather_list.append(" ")
        weather_list.append(" ")
    return weather_list


def condition_helper(condition):
    global global_condition
    #Sunny, Cloudy, Snowy, Rainy, Windy, Icy, JustStayHome
    condition = condition.lower()
    print condition
    if "sunny" in condition:
        global_condition = "Sunny"
    elif "clear" in condition:
        global_condition = "Sunny"
    elif "rain" in condition:
        global_condition = "Rainy"
    elif "showers" in condition:
        global_condition = "Rainy"
    elif "drizzle" in condition:
        global_condition = "Rainy"
    elif 'cloud' in condition:
        global_condition = "Cloudy"
    elif 'cloudy' in condition:
        global_condition = "Cloudy"
    elif "snow" in condition:
        global_condition = "Snowy"
    elif "dust" in condition:
        global_condition = "Windy"
    elif "blowing" in condition:
        global_condition = "Windy"
    elif "windy" in condition:
        global_condition = "Windy"
    elif "sleet" in condition:
        global_condition = "Icy"
    elif "hail" in condition:
        global_condition = "Icy"
    else:
        global_condition = "JustStayHome"


def playName(name):
        pygame.mixer.init()
        name = name + ".ogg"
        pygame.mixer.music.load("sound/" + name)
        pygame.mixer.music.play()
        while pygame.mixer.music.get_busy() == True:
                continue
        return


def playTemp(temp,condition):
        pygame.mixer.init()
        pygame.mixer.music.load("sound/" + "TemperatureTodayIs.ogg")
        pygame.mixer.music.play()
        while pygame.mixer.music.get_busy() == True:
                continue
        tempStr = str(temp);
        tempStr = "" + tempStr + ".ogg"
        pygame.mixer.music.load("sound/" + tempStr)
        pygame.mixer.music.play()
        while pygame.mixer.music.get_busy() == True:
                continue
        pygame.mixer.music.load("sound/" + "Degrees.ogg")
        pygame.mixer.music.play()
        while pygame.mixer.music.get_busy() == True:
                continue
        pygame.mixer.music.load("sound/" + "fahrenheit.ogg")
        pygame.mixer.music.play()
        while pygame.mixer.music.get_busy() == True:
                continue
        tempStr2 = condition + ".ogg"
        pygame.mixer.music.load("sound/" + tempStr2)
        pygame.mixer.music.play()
        while pygame.mixer.music.get_busy() == True:
                continue
        return


def travelTime(time):
        pygame.mixer.init()
        timeStr = str(time)
        timeStr = "" + timeStr + ".ogg"
        pygame.mixer.music.load("sound/" + timeStr)
        pygame.mixer.music.play()
        while pygame.mixer.music.get_busy() == True:
                continue
        pygame.mixer.music.load("sound/" + "MinuteTravelTimeToClass.ogg")
        pygame.mixer.music.play()
        while pygame.mixer.music.get_busy() == True:
                continue
        return


def packageData():
    tt = get_traffic_api()
    wl = get_word_api()
    fc = get_weather_api()
    str = yourname + "_" + tt + "_" + wl[0] + "_" + wl[1] + "_" + wl[2] + "_" + fc[0] + u'\N{DEGREE SIGN}' + "F" + "_" + fc[1]
    return str


def playsounds(name, delay):
    playName(yourname)
    playTemp(global_temperature, global_condition)
    travelTime(global_travelminute)


def PIR_UPDATE(threadName, delay):
    global globalpin
    print threadName + " " + str(delay)
    while True:
        try:
            while True:
                if(io.input(pir)):
                    globalpin = 1
                    print "motion detected"
                    time.sleep(75)
        except KeyboardInterrupt:
            print "cleaning up io pins"
            io.cleanup()

print packageData()
#playsounds()

class WSHandler(tornado.websocket.WebSocketHandler):
    def open(self):
        print 'new connection'
        self.write_message(packageData())
        #thread.start_new_thread(playsounds, ("Thread-1", 2, ))

    def on_message(self, message):
        global globalpin
        print message
        if message == "1" and globalpin == 1: #and if gpio flag is set writeback, otherwise return nothing
            print "writing back"
            self.write_message(packageData())
	    thread.start_new_thread(playsounds, ("Thread-1", 2, ))
            globalpin = 0

    def on_close(self):
        print 'connection closed'

    def check_origin(self, origin):
        return True

application = tornado.web.Application([
    (r'/ws', WSHandler),
])


if __name__ == "__main__":
    http_server = tornado.httpserver.HTTPServer(application)
    http_server.listen(8080)
    myIP = socket.gethostbyname(socket.gethostname())
    print '*** Websocket Server Started at %s***' % myIP
    thread.start_new_thread(PIR_UPDATE, ("Thread-1", 2, ))
    tornado.ioloop.IOLoop.instance().start()




